<?php
  /**
   * Comment's define config
   *
   * @author Matthew McNaney <mcnaney at gmail dot com>
   * @version $Id: config.php 5472 2007-12-11 16:13:40Z jtickle $
   */

define('DEFAULT_ANONYMOUS_TITLE', dgettext('comments', 'Anonymous')); // What an anonymous poster is called

/**
 * If you allow anonymous users to post and enter their name, you may
 * want to mark their name somehow. The COMMENT_ANONYMOUS_TAG _only_ appears
 * if the user was anonymous. You can make it a word, image, or just an activation
 * space.
 */
define('COMMENT_ANONYMOUS_TAG', dgettext('comments', '(Anon)'));


define('COMMENT_DATE_FORMAT', '%c');

// Maximum dimensions of an user's avatar graphic
define('COMMENT_MAX_AVATAR_WIDTH', 150);
define('COMMENT_MAX_AVATAR_HEIGHT', 150);


/**
 * There is alternate set of templates for comments
 * The alternate set uses avatar images.
 */
define('COMMENT_VIEW_TEMPLATE', 'alt_view.tpl');
define('COMMENT_VIEW_ONE_TPL', 'alt_view_one.tpl');

//define('COMMENT_VIEW_TEMPLATE', 'view.tpl');
//define('COMMENT_VIEW_ONE_TPL', 'view_one.tpl');


// This phrase will appear if a person doesn't enter a subject line
// for their comment.
define('COMMENT_NO_SUBJECT', dgettext('comments', 'No subject'));

// 10, 20, or 50 comments per page.
define('COMMENT_DEFAULT_LIMIT', 20);

?>